<?php
/**
 * Estate Rental Listings functions and definitions
 *
 * @package Estate Rental Listings
 */

if ( ! defined( 'ESTATE_RENTAL_LISTINGS_VERSION' ) ) {
	// Replace the version number of the theme on each release.
	define( 'ESTATE_RENTAL_LISTINGS_VERSION', '1.0.0' );
}

function estate_rental_listings_setup() {

	load_theme_textdomain( 'estate-rental-listings', get_template_directory() . '/languages' );
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'title-tag' );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( 'woocommerce' );
	add_theme_support( "align-wide" );
	add_theme_support( "responsive-embeds" );

	register_nav_menus(
		array(
			'menu-1' => esc_html__( 'Primary', 'estate-rental-listings' ),
			'social-menu' => esc_html__('Social Menu', 'estate-rental-listings'),
		)
	);

	add_theme_support(
		'html5',
		array(
			'search-form',
			'comment-form',
			'comment-list',
			'gallery',
			'caption',
			'style',
			'script',
		)
	);

	add_theme_support(
		'custom-background',
		apply_filters(
			'estate_rental_listings_custom_background_args',
			array(
				'default-color' => '#fafafa',
				'default-image' => '',
			)
		)
	);

	add_theme_support( 'customize-selective-refresh-widgets' );

	add_theme_support(
		'custom-logo',
		array(
			'height'      => 250,
			'width'       => 250,
			'flex-width'  => true,
			'flex-height' => true,
		)
	);

    add_theme_support( 'post-formats', array(
        'image',
        'video',
        'gallery',
        'audio', 
    ));
	
}
add_action( 'after_setup_theme', 'estate_rental_listings_setup' );

/**
 * Set the content width in pixels, based on the theme's design and stylesheet.
 *
 * Priority 0 to make it available to lower priority callbacks.
 *
 * @global int $estate_rental_listings_content_width
 */
function estate_rental_listings_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'estate_rental_listings_content_width', 640 );
}
add_action( 'after_setup_theme', 'estate_rental_listings_content_width', 0 );

/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */
function estate_rental_listings_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Sidebar', 'estate-rental-listings' ),
			'id'            => 'sidebar-1',
			'description'   => esc_html__( 'Add widgets here.', 'estate-rental-listings' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 1', 'estate-rental-listings' ),
			'id'            => 'footer-1',
			'description'   => esc_html__( 'Add widgets here.', 'estate-rental-listings' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 2', 'estate-rental-listings' ),
			'id'            => 'footer-2',
			'description'   => esc_html__( 'Add widgets here.', 'estate-rental-listings' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 3', 'estate-rental-listings' ),
			'id'            => 'footer-3',
			'description'   => esc_html__( 'Add widgets here.', 'estate-rental-listings' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);
}
add_action( 'widgets_init', 'estate_rental_listings_widgets_init' );


function estate_rental_listings_social_menu()
    {
        if (has_nav_menu('social-menu')) :
            wp_nav_menu(array(
                'theme_location' => 'social-menu',
                'container' => 'ul',
                'menu_class' => 'social-menu menu',
                'menu_id'  => 'menu-social',
            ));
        endif;
    }


/**
 * Enqueue scripts and styles.
 */
function estate_rental_listings_scripts() {

    // Load fonts locally
    require_once get_theme_file_path('revolution/inc/wptt-webfont-loader.php');

    // Define font families
    $estate_rental_listings_font_families = array(
        'Inter:ital,wght@0,100..900;1,100..900',
        'DM Serif Display:ital@0;1',
    );

    // Build Google Fonts URL
    $query_args = array(
        'family' => urlencode(implode('&family=', $estate_rental_listings_font_families)),
        'display' => 'swap',
    );

    $fonts_url = add_query_arg($query_args, 'https://fonts.googleapis.com/css2');

    // Enqueue Google Fonts using the wptt_get_webfont_url function to load locally
    wp_enqueue_style('estate-rental-listings-google-fonts', wptt_get_webfont_url($fonts_url), array(), null);

    // Font Awesome CSS
    wp_enqueue_style('font-awesome-6', get_template_directory_uri() . '/revolution/assets/vendors/font-awesome-6/css/all.min.css', array(), '6.7.2');

    // Enqueue Owl Carousel CSS
    wp_enqueue_style('owl-carousel', get_template_directory_uri() . '/revolution/assets/css/owl.carousel.css', array(), '2.3.4');

    // Enqueue theme's main stylesheet
    wp_enqueue_style('estate-rental-listings-style', get_stylesheet_uri(), array(), wp_get_theme()->get('Version'));

	// Add custom inline styles
    require get_parent_theme_file_path('/custom-style.php');
    wp_add_inline_style('estate-rental-listings-style', $estate_rental_listings_custom_css);

    // Enqueue navigation script
    wp_enqueue_script('estate-rental-listings-navigation', get_template_directory_uri() . '/js/navigation.js', array(), wp_get_theme()->get('Version'), true);

    // Enqueue Owl Carousel script
    wp_enqueue_script('owl-carousel', get_template_directory_uri() . '/revolution/assets/js/owl.carousel.js', array('jquery'), '2.3.4', true);

    // Enqueue custom JS
    wp_enqueue_script('estate-rental-listings-custom-js', get_template_directory_uri() . '/revolution/assets/js/custom.js', array('jquery'), wp_get_theme()->get('Version'), true);

    // Enqueue comment-reply script on singular pages if needed
    if (is_singular() && comments_open() && get_option('thread_comments')) {
        wp_enqueue_script('comment-reply');
    }
}
add_action('wp_enqueue_scripts', 'estate_rental_listings_scripts');



if (!function_exists('estate_rental_listings_related_post')) :
    /**
     * Display related posts from same category
     *
     */

    function estate_rental_listings_related_post($post_id){        
        $estate_rental_listings_categories = get_the_category($post_id);
        if ($estate_rental_listings_categories) {
            $estate_rental_listings_category_ids = array();
            $estate_rental_listings_category = get_category($estate_rental_listings_category_ids);
            $estate_rental_listings_categories = get_the_category($post_id);
            foreach ($estate_rental_listings_categories as $estate_rental_listings_category) {
                $estate_rental_listings_category_ids[] = $estate_rental_listings_category->term_id;
            }
            $estate_rental_listings_count = $estate_rental_listings_category->category_count;
            if ($estate_rental_listings_count > 1) { ?>

         	<?php
		$estate_rental_listings_related_post_wrap = absint(get_theme_mod('estate_rental_listings_enable_related_post', 1));
		if($estate_rental_listings_related_post_wrap == 1){ ?>
                <div class="related-post">
                    
                    <h2 class="post-title"><?php esc_html_e(get_theme_mod('estate_rental_listings_related_post_text', __('Related Post', 'estate-rental-listings'))); ?></h2>
                    <?php
                    $estate_rental_listings_cat_post_args = array(
                        'category__in' => $estate_rental_listings_category_ids,
                        'post__not_in' => array($post_id),
                        'post_type' => 'post',
                        'posts_per_page' =>  get_theme_mod( 'estate_rental_listings_related_post_count', '3' ),
                        'post_status' => 'publish',
						'orderby'           => 'rand',
                        'ignore_sticky_posts' => true
                    );
                    $estate_rental_listings_featured_query = new WP_Query($estate_rental_listings_cat_post_args);
                    ?>
                    <div class="rel-post-wrap">
                        <?php
                        if ($estate_rental_listings_featured_query->have_posts()) :

                        while ($estate_rental_listings_featured_query->have_posts()) : $estate_rental_listings_featured_query->the_post();
                            ?>

                            <div class="card-item rel-card-item">
								<div class="card-content">
                                    <?php if ( has_post_thumbnail() ) { ?>
                                        <div class="card-media">
                                            <?php estate_rental_listings_post_thumbnail(); ?>
                                        </div>
                                    <?php } else {
                                        // Fallback default image
                                        $estate_rental_listings_default_post_thumbnail = get_template_directory_uri() . '/revolution/assets/image/projects3.png';
                                        echo '<img class="default-post-img" src="' . esc_url( $estate_rental_listings_default_post_thumbnail ) . '" alt="' . esc_attr( get_the_title() ) . '">';
                                    } ?>
									<div class="entry-title">
										<h3>
											<a href="<?php the_permalink() ?>">
												<?php the_title(); ?>
											</a>
										</h3>
									</div>
									<div class="entry-meta">
                                        <?php
                                        estate_rental_listings_posted_on();
                                        estate_rental_listings_posted_by();
                                        ?>
                                    </div>
								</div>
							</div>
                        <?php
                        endwhile;
                        ?>
                <?php
                endif;
                wp_reset_postdata();
                ?>
                </div>
                <?php } ?>
                <?php
            }
        }
    }
endif;
add_action('estate_rental_listings_related_posts', 'estate_rental_listings_related_post', 10, 1);

function estate_rental_listings_sanitize_choices( $estate_rental_listings_input, $estate_rental_listings_setting ) {
    global $wp_customize; 
    $estate_rental_listings_control = $wp_customize->get_control( $estate_rental_listings_setting->id ); 
    if ( array_key_exists( $estate_rental_listings_input, $estate_rental_listings_control->choices ) ) {
        return $estate_rental_listings_input;
    } else {
        return $estate_rental_listings_setting->default;
    }
}

//Excerpt 
function estate_rental_listings_excerpt_function($estate_rental_listings_excerpt_count = 35) {
    $estate_rental_listings_excerpt = get_the_excerpt();
    $estate_rental_listings_text_excerpt = wp_strip_all_tags($estate_rental_listings_excerpt);
    $estate_rental_listings_excerpt_limit = (int) get_theme_mod('estate_rental_listings_excerpt_limit', $estate_rental_listings_excerpt_count);
    $estate_rental_listings_words = preg_split('/\s+/', $estate_rental_listings_text_excerpt); 
    $estate_rental_listings_trimmed_words = array_slice($estate_rental_listings_words, 0, $estate_rental_listings_excerpt_limit);
    $estate_rental_listings_theme_excerpt = implode(' ', $estate_rental_listings_trimmed_words);

    return $estate_rental_listings_theme_excerpt;
}


// Add admin notice
function estate_rental_listings_admin_notice() { 
    global $pagenow;
    $estate_rental_listings_theme_args      = wp_get_theme();
    $estate_rental_listings_meta            = get_option( 'estate_rental_listings_admin_notice' );
    $name            = $estate_rental_listings_theme_args->__get( 'Name' );
    $estate_rental_listings_current_screen  = get_current_screen();

    if( !$estate_rental_listings_meta ){
	    if( is_network_admin() ){
	        return;
	    }

	    if( ! current_user_can( 'manage_options' ) ){
	        return;
	    } 
		
		if( $estate_rental_listings_current_screen->base !== 'appearance_page_estate_rental_listings_guide' && 
            $estate_rental_listings_current_screen->base !== 'toplevel_page_estaterentallistings-demoimport' ) { ?>

            <div class="notice notice-success estate-rental-listings-welcome-notice">
                <p class="estate-rental-listings-dismiss-link">
                    <strong>
                        <a href="<?php echo esc_url( add_query_arg( 'estate_rental_listings_admin_notice', '1' ) ); ?>">
                            <?php esc_html_e( 'Dismiss', 'estate-rental-listings' ); ?>
                        </a>
                    </strong>
                </p>

                <div class="estate-rental-listings-welcome-notice-wrap">
                    <h2 class="estate-rental-listings-notice-title">
                        <span class="dashicons dashicons-admin-home"></span> 
                        <?php 
                            $estate_rental_listings_theme_name = wp_get_theme()->get( 'Name' );
                            /* translators: %s!: Theme Name. */
                            echo esc_html( sprintf( __( 'Welcome to the free theme: %s!', 'estate-rental-listings' ), $estate_rental_listings_theme_name ) );
                        ?>
                    </h2>
                    <p class="estate-rental-listings-notice-desc">
                        <?php esc_html_e( 'Get started by exploring the features of your new theme. Customize your design, add your content, and create a site that fits your vision.', 'estate-rental-listings' ); ?>
                    </p>

                    <div class="estate-rental-listings-welcome-info">
                        <div class="estate-rental-listings-welcome-thumb">
                            <img src="<?php echo esc_url( get_stylesheet_directory_uri() . '/screenshot.png' ); ?>" alt="<?php esc_attr_e( 'Theme Screenshot', 'estate-rental-listings' ); ?>">
                        </div>

                        <div class="estate-rental-listings-welcome-import">
                            <h3><span class="dashicons dashicons-download"></span> <?php esc_html_e( 'Quick Start: Import Demo', 'estate-rental-listings' ); ?></h3>
                            <p><?php esc_html_e( 'Use the Demo Importer to quickly set up your site with a pre-made layout. Get a complete site in minutes.', 'estate-rental-listings' ); ?></p>
                            <p><a class="button info-link button-primary" href="<?php echo esc_url( admin_url( 'themes.php?page=estaterentallistings-demoimport' ) ); ?>"><?php esc_html_e( 'Go to Demo Importer', 'estate-rental-listings' ); ?></a></p>
                        </div>

                        <div class="estate-rental-listings-welcome-getting-started">
                            <h3><span class="dashicons dashicons-art"></span> <?php esc_html_e( 'Customize Your Theme', 'estate-rental-listings' ); ?></h3>
                            <p><?php esc_html_e( 'Want to make it truly yours? Explore the Getting Started Guide to personalize your site to suit your needs.', 'estate-rental-listings' ); ?></p>
                            <p><a class="info-link button" href="<?php echo esc_url( admin_url( 'themes.php?page=estate-rental-listings-getstart-page' ) ); ?>"><?php esc_html_e( 'View Getting Started Guide', 'estate-rental-listings' ); ?></a></p>
                        </div>
                    </div>
                </div>
            </div>

            <?php
        }

	}
}

add_action( 'admin_notices', 'estate_rental_listings_admin_notice' );

if( ! function_exists( 'estate_rental_listings_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
*/
function estate_rental_listings_update_admin_notice(){
    if ( isset( $_GET['estate_rental_listings_admin_notice'] ) && $_GET['estate_rental_listings_admin_notice'] = '1' ) {
        update_option( 'estate_rental_listings_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'estate_rental_listings_update_admin_notice' );


add_action('after_switch_theme', 'estate_rental_listings_setup_options');
function estate_rental_listings_setup_options () {
    update_option('estate_rental_listings_admin_notice', FALSE );
}

/**
 * Checkbox sanitization callback example.
 *
 * Sanitization callback for 'checkbox' type controls. This callback sanitizes `$estate_rental_listings_checked`
 * as a boolean value, either TRUE or FALSE.
 */
function estate_rental_listings_sanitize_checkbox($estate_rental_listings_checked)
{
    // Boolean check.
    return ((isset($estate_rental_listings_checked) && true == $estate_rental_listings_checked) ? true : false);
}

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/revolution/inc/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/revolution/inc/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/revolution/inc/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/revolution/inc/customizer.php';

/**
 * Breadcrumb File.
 */
require get_template_directory() . '/revolution/inc/breadcrumbs.php';

/**
 * Custom typography options for this theme.
 */
require get_template_directory() . '/revolution/inc/typography-options.php';


//////////////////////////////////////////////   Function for Translation Error   //////////////////////////////////////////////////////
function estate_rental_listings_enqueue_function() {
 
    /**
    * GET START.
    */
    require get_template_directory() . '/getstarted/estate_rental_listings_about_page.php';

    /**
    * DEMO IMPORT.
    */
    require get_template_directory() . '/demo-import/estate_rental_listings_config_file.php';

    define('ESTATE_RENTAL_LISTINGS_FREE_SUPPORT',__('https://www.revolutionwp.com/products/free-estate-wordpress-theme','estate-rental-listings'));
    define('ESTATE_RENTAL_LISTINGS_PRO_SUPPORT',__('https://www.revolutionwp.com/pages/community/','estate-rental-listings'));
    define('ESTATE_RENTAL_LISTINGS_REVIEW',__('https://wordpress.org/support/theme/estate-rental-listings/reviews/#new-post','estate-rental-listings'));
    define('ESTATE_RENTAL_LISTINGS_BUY_NOW',__('https://www.revolutionwp.com/products/property-rental-wordpress-theme','estate-rental-listings'));
    define('ESTATE_RENTAL_LISTINGS_LIVE_DEMO',__('https://demo.revolutionwp.com/estate-rental-listings-pro/','estate-rental-listings'));
    define('ESTATE_RENTAL_LISTINGS_PRO_DOC',__('https://demo.revolutionwp.com/wpdocs/estate-rental-listings-pro/','estate-rental-listings'));
    define('ESTATE_RENTAL_LISTINGS_LITE_DOC',__('https://demo.revolutionwp.com/wpdocs/estate-rental-listings-free/','estate-rental-listings'));
    
}
add_action( 'after_setup_theme', 'estate_rental_listings_enqueue_function' );


/**
 * Load Jetpack compatibility file.
 */
if ( defined( 'JETPACK__VERSION' ) ) {
	require get_template_directory() . '/revolution/inc/jetpack.php';

}

function estate_rental_listings_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'estate_rental_listings_remove_customize_register', 11 );

/************************************************************************************/
// //////////////////////////////////////////////

/**
 * WooCommerce custom filters
 */
add_filter('loop_shop_columns', 'estate_rental_listings_loop_columns');

if (!function_exists('estate_rental_listings_loop_columns')) {

	function estate_rental_listings_loop_columns() {

		$estate_rental_listings_columns = get_theme_mod( 'estate_rental_listings_per_columns', 3 );

		return $estate_rental_listings_columns;
	}
}

/************************************************************************************/

add_filter( 'loop_shop_per_page', 'estate_rental_listings_per_page', 20 );

function estate_rental_listings_per_page( $estate_rental_listings_cols ) {

  	$estate_rental_listings_cols = get_theme_mod( 'estate_rental_listings_product_per_page', 9 );

	return $estate_rental_listings_cols;
}

/************************************************************************************/

add_filter( 'woocommerce_output_related_products_args', 'estate_rental_listings_products_args' );

function estate_rental_listings_products_args( $estate_rental_listings_args ) {

    $estate_rental_listings_args['posts_per_page'] = get_theme_mod( 'custom_related_products_number', 6 );

    $estate_rental_listings_args['columns'] = get_theme_mod( 'custom_related_products_number_per_row', 3 );

    return $estate_rental_listings_args;
}

/************************************************************************************/

/**
 * Custom logo
 */

function estate_rental_listings_custom_css() {
?>
	<style type="text/css" id="custom-theme-colors" >
        :root {
           
            --estate_rental_listings_logo_width: <?php echo absint(get_theme_mod('estate_rental_listings_logo_width')); ?> ;   
        }
        .site-branding img {
            max-width:<?php echo esc_html(get_theme_mod('estate_rental_listings_logo_width')); ?>px ;    
        }         
	</style>
<?php
}
add_action( 'wp_head', 'estate_rental_listings_custom_css' );

function get_changelog_from_readme() {
    $estate_rental_listings_file_path = get_template_directory() . '/readme.txt'; // Adjust path if necessary

    if (file_exists($estate_rental_listings_file_path)) {
        $estate_rental_listings_content = file_get_contents($estate_rental_listings_file_path);

        // Extract changelog section
        $estate_rental_listings_changelog_start = strpos($estate_rental_listings_content, "== Changelog ==");
        $estate_rental_listings_changelog = substr($estate_rental_listings_content, $estate_rental_listings_changelog_start);

        // Split changelog into versions
        preg_match_all('/\*\s([\d\.]+)\s-\s(.+?)\n((?:\t-\s.+?\n)+)/', $estate_rental_listings_changelog, $estate_rental_listings_matches, PREG_SET_ORDER);
        
        return $estate_rental_listings_matches;
    }
    return [];
}